Version 2.5.8 - September 1, 2026
---------------------------------

(WIP) 6803 timer (MC bouncy ball OK but complete implementation expected)

(WIP) Corvus hard disk emulation

(WIP) Snapshots

(WIP) Orchestra 90 for CoCo (needs verification, describe)

Reset FDC on Model I reset button press. {8355}

MX-70 now has printer sound effects on Mac. {8184}

Model 4P defaults to having hires Tandy graphics. {8351}

FreHD always given short file names on Windows even when it refuses. {8357}

Don't force cursor off when directly loading /CMD files. {8373}
[ Only done for SYSTEM files by writing zero to $4022 ]

Fix errors in handling of non-autostart ROM cartridges (-pakq command). {8374}

Paste macros now available on Mac + Linux. {8379}

Paste macros can be set on command line (-imacN str). {8379}


Version 2.5.7.1 - June 14, 2026
-------------------------------

File Utility was crashing on Model 2 systems under MacOS {8176}

Disk summary has option to show likely empty sectors {8171}

Command line -im disksummary and -im disksummarye output disk image summaries {8171}


Version 2.5.7 - June 7, 2026
----------------------------

EMU hard drive images now correctly show CRC errors in disk summary {8113}

Fix corrupted data CRC caused by editing EMU hard drive sectors {8113}

Fixed audio corruption in .avi video recording {8088}

Debugger disassembly also shows the last few dozen completed instructions. {8079}

Backtrace now tracks the last 1,048,576 instructions, up from 65,536. {8079}

File import: CP/M files are forced to upper case. {8074}

Fix crash when tracing memory from CWAI on 6809. {8046}

Reformatting DREM hard drives images will now update .cfg parameters. {8045}

File import: fix duplicate entries and Model II defaults to Program type. {8035}

Detaching second hard drive no longer detaches primary hard drive. {7998}

Hard drives now implement write protect. {8032}

Hires graphics (-gt, -gg) can now be selected for Model 4D. {8072}

Windows debugger completely fills memory and disasssembly windows at start. {8079}

Z-80 single stepping now shows memory permission faults when single stepping. {8079}

Backtrace no longer shows 64K bogus instructions if triggered at start. {8079}


Version 2.5.6 - January 17, 2026
--------------------------------

Green Thumb emulation.

Improved IM 0 mode for Model I allowing TPM to format a diskette. {7789} 

Supermem (-mem supermem) and X-MEM/80 support for Model 1 (-mem xmem80). {7793}

Fixed Mac context menu {7687}

Implemented "load" and "run" script commands. {7695}

Use only 4 bits of FreHD commands like the real FreHD. {7694}

Model 12, etc. back to immediately reacting to bank swap (port $A8).  {7714}

Memory views no longer wrap around to address 0; it was too confusing. {7724}

Added "feed" and "delay" script commands. {7735}

Backtrace now annotated with labels when they are available. {7741}

Fixed Mac debug disassembly window for some processors. {7768}

6809 subtract/compare operations no longer modify the half-carry flag. {7795}

IMD disk image saves blank tracks as empty records, allows HxC 0x80 modes. {7796}

Directly loaded Model 1 and 3 BASIC programs now convert ^ to [ {7780}

Add delay to FDC Restore to fix Arranger II adding disks.{7832}

Disk viewer can be used to modify sector data. {7843}

Printer menu options for 80 and 132 column fixed-width printing. {7859}

RS-232 transmit interrupt asserted at when RS-232 reset. {7886}

Gendon character ROM available for model 1 via -charrom :gendon {7888}

Disk viewer/disk summary works correctly for hard drives using sector ID ranges 1..n {7908}


Version 2.5.5 - June 1, 2025
----------------------------

Debug -> File Utility window to examine and manipulate disk files. {7431 and beyond}

Scripting commands to control TRS-80 and UI. https://48k.ca/trs80gp.html#script {7675}

Add your own commands to Custom menu with -menu {7663}

Run commands at boot with -cmd {7669}

Run commands along with with automatic input using -icmd {7590}

Keyboard auto de-turbo now works on linux and mac. {7582}

Can pass arguments to endpoints: -p [ :mx70 -mute ] {7586}

Serial port, printer and other dialogs have explicit enable checkbox. {7677}

Motorola S-record file loading. {7570}

Fix linux crash when resizing window in turbo mode. {7582}

Fix linux crash when media key like "pause" or "next track" pressed. {7681}

Fix crash/emulation errors when examining active HFE disk images in Disk Viewer. {7416}

Fix crash formatting single-density only DMK files as double density. {7353}

"Typing" keyboard layout (-kl typ) better for Level 1, TRSDOS 2.3, CP/M input. {7614}

Keyboard layout and ghosting now remembered as user preferences. {7614}

Paste modes for injecting text on unsupported operating systems + programs. {7617}

Added "-ib file" to run trs80gp script commands from a file. {7630}

Input system (-i flags) timing more consistent and useful. {7638}

Added "-ifr file" to paste in a file with no line ending translation. {7657}

Direct loaded BASIC programs can have multiple-line lines. {7660}

Bus tracing can be limited to address ranges with -tr low:high,l2:h2 {7395}

Output registers to bus trace with -trpr A,HL or similar {7395}

Loading symbols with -ls still allows boot into DOS. {7469}

Symbols now appear in profiler output. {7473}

Copy screen to clipboard sometimes failed in graphics-only mode under Windows. {7597}

-cix option to turn off warning when cassette I/O seen and interrupts enabled. {7571}

Trim trailing spaces and blank lines when copying text screen. {7571}

Pasting to Tandy 10 faster and more reliable. {7612}

Add "save image" to printer window in Windows. {7583}

MX-70 can automatically pause at the end of every page. {7575}

MX-70 tractor feed and perforations can be turned off. {7577}

MX-70 reset puts printer into default mode; cold restart drops pages. {7583}

MX-70 no longer gets bad line height if high bit set in size. {7583}

Stop -turbo from skipping renders; it was triggering legacy code. {7583}

On Windows sub-processes like from -p :mx70 don't steal the focus. {7579}

IMD/JV3 with CRC errors now report those errors to the FDC. {7632}

Blank double-sided diskette images moved to Other submenu to reduce clutter. {7594}

Add Cassette to Device Viewer.


Version 2.5.4 - November 17, 2024
---------------------------------

Tandy 10 emulation.

Stop quadratic slowdown as printer output grows.

Hardware serial port access on linux and mac via -r /dev/tty/USB0 or such.

Becker port support for CoCo; -bck host:port or Serial -> Becker menu. {7144}

68000 debugger for Model 16/6000 was always single stepping. {7164}

MC-10 PEEK(2) quick keyboard check working; helps many Jim Gerrie games. {7329}

Correct Model 3 and 4 memory mapped printer port to be read-only. {7121}

Control of delay before cassette auto-save via -csd or Cassette -> Save menu. {7123}

Cassette now starts if inserted while CLOAD or SYSTEM in progress. {7327}

Show .wav files in cassette open dialog by default if supported. {7328}

Less awkward breakpoint GUI with a single window and addr1:addr2 for ranges.

Printing on LDOS no longer reboots; emulator ignored printer interrupt disable. {7192}

Model 2 hard-drive TRSDOS booting again.  Oddly, same bug as LDOS printing. {7192}

Replaced patched TRSDOS with proper Japanese TRSDOS. {7326}

Allow Model 2/12/16/6000 access to Orchestra 90.  Theoretically possible. {7122}

Real Time Clock for Xenix enabled by default and now controlled by -rtc16 -rtc16x. {7344}

CoCo cassette relay sound effects.

CoCo Program Pak autostart control via menu or turned off by -pakq file.ccc.

Printer window auto scrolls to bottom again on output. {7191}

DT-1 half intensity display mode implemented. {7296}

Event stream (-event endpoint) allowing external programs to blink LEDs, etc.

Minor .wav output correction as .wav files should be an even number of bytes. {7168}

CoCo FDC timing adjusted to hit 300 RPM precisely. {7182}

FreHD emulation supports DSK/DCT LDOS driver to mount read-only disk images. {7334}


Version 2.5.3 - April 23, 2024
------------------------------

Model 1, 3, 4 now accept .wav files as cassette input.

Add -pp/-ppx options to control printer window pop-up.

$37EA and $37EB are now memory mapped printer port aliases on Model I.

Model 1 RS-232 sense switches (thanks to Tuc for hardware tests).

Model 1/3/4 RS-232 receive bug fixed.

Add loopback device to RS-232 choices (-r :loop on command line)

Add -rx option to disable RS-232 on Model 1,2,3,4,12,16.

CoCo BASIC ROM 1.0 printer output fixed.

Text pasting works for CoCo 1.0 and 1.1 ROMs.

Semigraphics 6 modes will display alternate palette (Electric Crayon, MC-10, CoCo).

Printer auto-turbo works for all models now.

Add "-im disksummary" and disksummary on drive exports to output a summary
of drive structure just like the Disk Viewer window.

Model 4 software keyboard no longer missing '+' character on keycap. {7106}

trs80gp -m1 -dx no longer loads lower case driver by default; use -lld to do so. {7007}


Version 2.5.2 - December 9, 2023
--------------------------------

Hard drive controller now correctly drops DRQ when READ buffer is finished,
fixing hard drive access from NEWDOS/80 2.5. {6871}

Model 2 family hires graphics no longer sometimes hang emulator.

Use Z-180 CPU with -z180 giving sufficient but incomplete XLR8er support.

Show location of memory search match in address text box.

Automated input no longer waits for input ready before proceeding.

Z-80 debugger EXX and other register exchange checkboxes would not always
reflect actual flip-flop states but registers would be correctly swapped.

Made Z-80 emulator extensions (-ee) easily accessible to BASIC with INP(71).

Z-80 debugger memory read traps now catch push/pop and other stack operations.

Debugger allows 'h' suffix on pasted hexadecimal input.

On Windows Shift+Insert and Shift+Delete working again in the debugger window.

On Windows Ctrl+A works for "Select All" on all text input boxes. {7142}

Windows version didn't notice when children from "-rA :dt1" and such went away.

Don't spuriously warn about interrupts when CMD"T":CLOAD and such are used.
CMD"T" doesn't immediately disable interrupts: https://48k.ca/cmdt.html

Automatic turbo mode when printing to printer; settable by menu or -pt/-ptx.

Pasted or command line input auto turbo controllable by menu or -iat/-iatx.

Significantly improved "-ip" throughput (was only 1 character/frame).

-itime 0 now disables input feed timeout.


Version 2.5.1 - September 3, 2023
---------------------------------

Linux joystick support.

Type current date/time with -iy '%m/%d/%y' or -iy '%h:%i:%s'; %Y is full year.
Model 2 users: trs80gp -m2 -iw YYYY -iy "%m/%d/%Y\r%h.%i.%s\r"

Support Color Computer SG-8 semigraphics mode

Color Computer Program Paks were limited to 8K due to a typo.

Color Computer reset works when in OS-9 or 64K mode in general.

Color Flex 5.0.4 keyboard input fixed (it was seeing entire columns at once).

Sound now audible on Color Computer Demon Attack.

Model 1 CLOAD fixed when using earlier ROM revisions under TRSDOS.

Model 1 LEVEL II BASIC data .cas files no longer mis-identified as 250 baud.

Warning if cassette used on Model 1 disk system without CMD"T" with option
to turn off interrupts so cassette operation will function properly.

Correctly exports first file on Aculab wafer rather than ejecting the wafer.

FreHD emulation bug on Windows prevented access to files with paths.

Linux "Change Model" would fail if trs80gp was not on the $PATH.

Some illegal EXG instructions could crash Videotex or CoCo.

halt, irq, nmi states in Z-80 in disassembly for less confusing stepping.

Stopped Z-80 suprious breakpoints in halt state or when interrupt pending.

68000 execution speed more realistic and decoupled from Z-80.

68000 speed selectable with -mhz16 N, default 8; closest to divisor of 312.

Approximate video beam dropouts in Model 2/12/16/6000.

Implemented import/export of Model II TRS-DOS variable length record files.

Scroll Lock and ctrl+shift+@ now work as Model 2/12/16/6000 HOLD key on linux.
And \0 will also simulate HOLD when used in -i or an Alt+N macro.


Version 2.5 - June 3, 2023
--------------------------

Color Computer emulation.

Device viewer can execute until value changes and show elapsed time/cycles.

Joystick support for MacOS.

Soft capslock (-ks) for Model 2 + 12; on by default if running TRS-DOS.

Debugger window title shows running/stopped and reason for stoppage.

Added -nrs to suppress loading of built-in symbols.

Model 3 ROM RS-232 init routine will now initialize it on the first call.

MC-10 audio is no longer corrupted after a reset.

MC-10 Cassette menu now showing tape position at end after a load.

Fix linux crash when starting with mute on in preferences.

File -> Unload Symbols functional again; it was almost always greyed out.

Electric Crayon CPU speed corrected; was running much too quickly.

Border colour preference was not being saved.

Stop Model 3 EDTASM from DDOOUUBBLLIINNGG characters in printouts.


Version 2.4.11 - March 6, 2023
------------------------------

Disk Viewer shows sectors in ID order instead of position.

Sound effects and stereo sound now implemented on macOS and Linux.

Preliminary Device Viewer added.

Improved command line parsing; model specifier always takes effect first.


Version 2.4.10 - December 10, 2022
----------------------------------

Snapshot save/load for Z-80 systems.

Japanese Model 1 can now run BASIC and SYSTEM programs from the command line.

CLOAD now works on earlier Model I ROM versions.

Fixed high speed cassette loading that was broken in 2.4.9

Model 3 TRSDOS has 2 more granules free by using fix at the end of:
https://www.trs-80.com/wordpress/zaps/trsdos-v13-unofficial/

Don't change default model when attaching a printer or terminal.

Blank HFE images will set data rate and RPM fields correctly for 8" drives.

Model 16 gets interrupt on MMU address faults.


Version 2.4.9 - October 8, 2022
-------------------------------

Japanese Model 1 emulation (-m1j)

Orchestra 85 and 90 now play in stereo on Windows.

LDOS DiskDISK floppy disk image support.

Disk drive and other sound effects on Windows.

Model 1,3,4 unmapped printer port bits now correctly float high.

MC-10 implements SG6 display mode properly.

Corrected various 6803 instruction timings for MC-10.

Slightly green text background for Electric Crayon, Videotex and MC-10.

Model 4 can be set up with 16K memory.  Or 0K as if no RAM is installed.

Various auto turbo modes now per-model preferences; settable on command line.

Disassembly windows show symbolic names for memory locations when available.

Memory view windows independent of debugger.

Bus use for MC-10 and Electric Crayon now functional.

Bus use no longer clearing loaded flag returning it to usefulness.

Edit -> Copy crashed in Videotex, Electric Crayon and MC-10 graphics mode.

F12 now activates turbo on linux.

.bds symbols and loading works on all CPUs, including the 68000.

Low probability .bds file loading hang/crash bug fixed.

68000 debugger upgraded to 18 breakpoints.

Model I RS Doubler ignores side select commands which didn't really exist.

Corvus hard drive emulation improved, added debugger (Windows only).


Version 2.4.8 - June 4, 2022
----------------------------

MC-10 emulation (-mc10).

Memory access breakpoints for 6800, 6803, 6809 and 68000 processors.

Bus trace for 6800, 6803 and 6809 processors.

Help in MacOS menu now opens the trs80gp manual.

Turbo turns off Haste mode and vice versa.

Cassette image can be ejected and shows currently loaded file in menu.

Debug -> Symbol Table to view all symbols from loaded .bds files.

Unbreak -m4b and -m4c as they were not removing wait states.

Removed spurious FreHD menu from DT-1, Videotex, Electric Crayon and MX-70.

Ctrl-A now selects all text in the printer window on Windows.


Version 2.4.7 - April 9, 2022
-----------------------------

-haste option faster than turbo but graphics emulation compromized.

Orchestra-90 support.

Added menu entry to unload symbols from previous .bds file/symbol loads.

FDC 0xd8 command modified so SuperUtilty boots with Percom doubler.

Add slight jitter on Model III disk emulation to handle problems with perfect 200ms rotations colliding with 60Hz interrupt.

Improved display of IDAM and DAM CRC errors in disk image debug tools.

Raspberry Pi version works on 64 bit Raspbian.


Version 2.4.6 - March 5, 2022
-----------------------------

Arrow keys on numeric keypad work in Linux.

FDC emulates head load delays, so file format for Model III PFS:file now works.

FDC fix to Type I status change after interrupt commands. The TRSDOS-II RESTORE command now works.

Disassembler window added.

FreHD images bootable via the FreHD menu as needed FreHD extensions emulated.

FreHD autoboot emulated.  Can set custom boot block with -fred_load file.

Can apply FreHD auto-start ROM patches with -frehd_patch.

New -rom1 option to load a ROM into the Model I "hole" from $3000 .. $37df.

Eliminated spurious wait states on $3C00 .. $3FFF in Model 4 memory map 2+3.

Corrected Unicode translation of Model III Greek letters Lambda to Rho.

No more annoying click in Windows when focus changes and mute is on.

Command line control over keyboard layout, ghosting and auto-de-turbo.

New option -kc shows clustered arrow key layout in software keyboard.

New option -m4d shows Model 4D layout in software keyboard.


Version 2.4.5 - December 4, 2021
--------------------------------

Lowe Electronics LS-18 Model I hires emulated (use -gl).

HyperMEM memory for Model 4 with -mem 256 (or 512 or 1024) or -mem hyper:512.

SuperMEM expansion memory for Model 4 with up to -mem super:1024 K.

MegaMEM expansion memory for Model 4 with up to -mem mega:16384 K.

Fixed hires memory debug view and dump.

Added '-ik row bits' for automated control of low-level keyboard input.

Added '-ig' to dump hires graphics memory.

8" drives default to restricting emulation to single or double sided.

Added -dNss, -dNds, -dNas to force floppy drive N to be single, double or any-sided.

Emulator extensions can now trigger audio and video recordings, screenshots.

Easy interface to emulator extensions from BASIC.

Model I TRSDOS 2.3 patched.  Pressing BREAK at first prompt no longer reboots.

Linux version no longer crashes on paste if the clipboard is empty.

Debug T-States/Cycles treats input as decimal instead of hex.

Added watch expressions to debugger.

Cassette counter and read/write indication in title bar during cassette I/O.

Mac version can save cassette output (.cas files) again.

Fix .bds load bug causing crashes on certain > 256 data lengths.

Stop right-hand glyph replacement when copying Model 3 Japanese unicode text.


Version 2.4.4 - September 4, 2021
---------------------------------

Raspberry Pi 32-bit (Raspian) and 64-bit (Ubuntu) versions.

MX-70 printer emulation (-mx70 or -p :mx70)

Authentic mode faster by redrawing only changed lines of display.

NEWDOS/80 can now format .imd format diskette images.

Additional views for Disk Debug window including a diskette summary.

-mmu16 n option to control number of extension bits of 68000 MMU (0 .. 3).

-memgap16 option to create gaps of unmmaped 68000 memory.

Orchestra-85 sound no longer noisy.

Add -nld to suppress loading lower-case driver in Model I cassette boot.

Stop crash when flag register checkbox clicked on windows.

Have entry point breakpoint of /CMD file loaded under a DOS trigger promptly.

Update window title at most every 10 frames on linux; change with -wtfs N

DREM hard drive loader uses .DSK or .dsk for data filename (Linux fix).

EMU hard drive blank tracks now same as ext2emu.

Formatting more than 128 tracks works for HFE and IMD.

Disk ASCII dump works on Super Utility (removed assert()).

HFEv3 floppy format will warn and not load (version 3 not supported).

IMD floppy format correctly reading/writing head/cylinder maps.

Floppy loading improved to fix memory leaks and allow larger images.

Memory leak fixes for cut/paste and bus tracing.

Model I RS Doubler detect modified so Super Utility doesn't trigger it immediately.

Disk debug window has additional views to show IDAM/DAM and disk summary.

Linux GTK version added icon for the main window.

Bus trace details interrupt status/mask bits for Model III.


Version 2.4.3 - June 6, 2021
----------------------------

Drag and drop to run program files.

68000 instruction fix has UNOS booting on Model 16.

Instruction and data breakpoints in .BDS files allow automatic memory protection.

Debugger resizable and disassembly shows more by using full height of dialog.

-win command line option works in linux now.

Crude Orchestra-85 emulation.

Command line loading of SYSTEM programs turns off cursor before running them.

Preliminary cassette I/O in in .cpt (Cassette Pulse Train) format.

Cassette file mounting breaks out individual files better and crashes less.

Keyboard ghosting menu option.


Version 2.4.2 - March 6, 2021
-----------------------------

RM/COS for the model 16 boots (fixes to floppy status; 68000 STOP, Scc inst.).

Omikron mapper emulation for Model I (-omikron).

Support for HxC2001 HFE floppy format.

68000 debugger now has execution breakpoints; can set with command line -b16 

Added interrupt and address bus tracing to 68000 trace output.

Diskette -> Replace only ejects if a new diskette is chosen.

Remove Debug -> Disk Viewer... if no disk drives or hard drives attached.

GIF recording timing more accurate when possible.

Experimental Logical Layout keyboard mode for a certain custom CP/M BIOS.

Caps lock on mac now toggles properly.  But may be out of phase with keyboard led.


Version 2.4.1 - January 5, 2021
-------------------------------

Critical bug fix where .jv1, .jv3 and .imd disk drives were not saving changes.

Windows version remembers window positions and display modes.  This includes
a notion of "instances" which have their own preferences and show "#2", "#3",
etc. in their window title.

FreHD firmware and boot versions to 9.08 and 7.06 to avoid frehd.rom bugs.

Command line -sx option to disable audio output entirely.

Unmapped memory regions now display in debugger as ~ff (or ~00 on the Model II).

Keyboard input can be fed in via TCP/IP with -ip @port or Keyboard -> Connection.

Don't crash when given a floppy image for DT-1, Videotex or "-b 0" for DT-1.

MacOS wasn't filling in disk view hex data or debugger hex data.

Z-80 debugger wasn't updating I and R register displays in MacOS.

Linux custom colour picking works now.


Version 2.4 - December 3, 2020
------------------------------

Linux beta version.

Videotex terminal emulation (use -mv)

Electric Crayon emulator; -p :ec or choose Electric Crayon in Printer -> Connection

TCP/IP printer support with "-p host:port" (like -r option is for serial ports)

Works on Windows XP again (removed a trivial dependency).

Fix crash due to format mis-identification when loading up certain .cas images.

Command line breakpoints support range syntax. e.g., "-b 5200:6000".

Floppy disk doubler detection for Model I improved.

ENTER key works from "all pressed" location in logical mode.

Stop audio from popping when continuous tones played.

Add various "-ir" command-line options to trigger audio and video recording.

Add "-su" command line option to turn off audio filtering.

FreHD directory settable to ease IMPORT2/EXPORT2 usage (command line and menu).

DT-1 Setup -> Save Setup wasn't saving the settings correctly.

Stop crashing if screenshot or animated GIF save file dialog is cancelled.


Version 2.3.2 - August 20, 2020
-------------------------------

DT-1 (Data Terminal 1).  Use -mdt1

Add -rand so games run on command line aren't always the same.

Turbo mode displays multiplier and can change after startup on Mac and Linux.

Mute and Volume are now per-model preferences (i.e., saved between runs).

Refined floppy timing.

Format will promote single-sided floppy images to double-sided.

Physical keyboard layout better approximates original key positions
(especially the arrow keys).

Preliminary mouse emulation with "-r :mouse" or use "Serial" menu.

Keys F3 .. F8 work on Model 2/12/16/6000.


Version 2.3.1 - May 30, 2020
----------------------------

Alpha joystick emulation on Windows.

Software keyboard for Mac.

PCG-80, 80-Grafix, 80-Grafix+ and 80-Grafix III programmable character graphics.

Z-80 debugger can set ranged breakpoints on memory read/write and I/O in/out.

Floppy and hard drive sector viewer.

Memory and disk search capability (in Z-80 debugger and Disk Viewer).

Alt-0 though Alt-9 are user-definable keyboard macros (Edit menu) [windows].

Floppy command delay added; Sledge of Rahmul and other Duo-Loader games boot.

Return floppy sector type fixing Zork boot and improved write protect handling.

Right-shift on Model 1 logical keyboard working again.

Hard drive emulation supports WD2010 mode with up to 2048 cylinders.

JV3 format floppies with more than 40 tracks work now.

Now have warm and cold restart with the latter re-initializing RAM.

Xenix printing much faster as Model 2/16 emulation generates printer interrupts.

Model 1/3/4 logical keyboard now maps '^' to '['.  This may help someone who's
entering BASIC from a listing that shows '^' for exponentiation.

Add Backslash as CLEAR in logical mode (not just physical); better for Macs.

Micro Matrix Photopoint light pen emulation for Model 1,3,4 (-lp) [windows].

Load custom character generator ROM with -charrom

Add -l file to load but not execute a file on the command line.

Add -ls file, Load Symbols... to load only the symbols from a BDS file.

Model 2 etc. hires displays properly CRTC start address changes (e.g., when Xenix scrolls)

Model 4 LS-DOS now has drives 0,1,2,3 instead of 0,1,3,4

Fixed occasional character drop when pasting large amounts of text.

Only show gray bars above and below Model 4's 64 column mode in beam debug.

Add -tsr flag for laughs.  Or rename your executable to tsr80gp.exe


Version 2.3 - February 29, 2020
-------------------------------

Support for hard drives.

Model 16 emulation.

Preliminary support for Model I Percom and Radio Shack double-density disk interfaces.

Model II double-sided floppy support.

Montezuma CP/M no longer misses shift keys regularly.

If a disk FORMAT proceeds beyond the last track, DMK and IMD append blank tracks.

DMK format detection rules relaxed to allow for larger file truncation.

No longer get down-arrow stuck when using Ctrl+Alt+V and the like.

Debugger memory, disassembly and stack update on reset or change in memory map.

Cassette auto-save capture Scott Adams Adventures saves one instead of two files.

New Model II ROM now the default; get original with "-r0".

Added Model 1 revision 1.1 ROM and -nlc not needed for earlier ROM revisions.

-dN tries adding .dmk, .imd, .jv3, .jv1 and .dsk to files it can't find.

Windows menu key brings up the right-click context menu.

Animated GIF output usually smaller by extending the delay for repeated frames.

Debugger now shows Model II ROM contents and disassembly when it is mapped in.

Single stepping in debugger updates the trace window even if tracing is off.

Current drive track is displayed status bar.

Writes to Model 4P ROM now go to RAM.

-write_rom allows Z-80 to write to ROM on Model I and III.

-m1_vblank makes VBLANK readable from bit 0 of port $FF (Model I only).


Version 2.1.2 - July 16, 2019
-----------------------------

CP/M Plus 1.00 for Model 4 now boots.

Improve formatted track conversion for IMD disk images.

Model I LDOS diskette 2 now inserted in drive 2 instead of diskette 1.

Handle .jv1 disk images with more than 40 tracks.

-frehd supports file writing so EXPORT2/CMD works.

Internal disk images loadable on command line with :name or "-d :name"

Added internal utility diskettes :tu1, :tu2, :tu3, :tu4, :lu1, :lu2, :lu3, :lu4
for TRSDOS/LDOS Model 1 .. 4 containing import2, export2 and vhdutl.  And
:t4u2 for TRSDOS 4 Model II.

Added pre-formatted internal diskettes :tb1 .. :tb4, :lb1 .. :lb4 and :t4b2
for TRSDOS and LDOS and TRSDOS 4 Model II.

Aculab Floppy Tape emulation for Model I.

Don't allow load or run to overwrite ROM.

Check for reasonable BASIC program start address when loading BASIC programs.

Remove spurious complaint about lack of entry point when running BASIC programs.

Super Utility for Model I and Model 4 boot (A1_REPAIR enabled).

Menu items deleted and checked as required when started in full screen.

Border colour now defaults to black and can be changed with -vb option.

Add Ctrl+Alt+R and Ctrl+Alt+L shortcuts for File -> Load and File -> Run

Relative T-state times in bus trace now reflect actual memory/IO access times.
Also some clean up of NMI and IRQ details.

Bus trace outputs nested curly braces to help track subroutine calls.

Toggling Z-80 flag checkboxes in debugger updates F register value and vice-versa.


Version 2.1.1 - March 13, 2019
------------------------------

LDOS and LS-DOS can now format .imd disk images.

Volume control with slider in Controls dialog box and -vol N option.

Some menu checkmarks (e.g., Record -> Audio) were not being updated.

Added -mute, -m4ga flags.

FreHD can be enabled/disabled with Diskette -> FreHD

-d now selects the first free drive instead of drive 0 erroneously.

Release notes now available in trs80gp itself via Help -> Release Notes.

Built-in double-sided (and unformatted) disk images added (e.g., -d dmk-ds)
And tracks beyond the default with #N (e.g., -d imd#44).

Preliminary trsnic emulation via -trsnic.

Corrected frequency of beep in Model 2.

EXTIO enable was incorrectly required for FreHD access on Model 1 and 2.


Version 2.1.0 - February 17, 2019
---------------------------------

Numerous bug fixes in floppy emulation especially around formatting.

.cmd files now loaded under TRSDOS/LSDOS rather than ROM BASIC.

Sound mute menu entry and auto-muting paused or using menus.

Full screen and new sharp rendering mode. (perfectly square pixels with scaling)
See -vf, -vs, -vi command line options and new View menu.

Reassigned and new hot keys:
	Alt-F5 - reset (also in File menu)
	Ctrl-Alt-F5 - cold reset (also in File menu)
	F9 - pause (also in File menu)
	F11 - screenshot
	Shift-F11 - clean shot (screen shot without beam conflict dropouts)
	F12 - turbo mode while held
	Shift-F12 - turbo mode (also in File menu)
	Alt-Enter - toggle full screen mode
	Ctrl-Alt-C, Ctrl-Insert - Copy
	Ctrl-Alt-V, Shift-Insert - Paste

Right-click context menu for easier cut/paste and exit of full screen mode.

Disk files recognized by .dmk, .imd, .dsk suffix so can be listed without
-dN on command line.  Or with just -d if suffix unknown.

Can insert unformatted blank disks with "-d dmk" and "-d imd".

Printer menu to turn off pop-up and turn off printer (also -poff).

Reset button and RAM badge added to soft keyboard.

Added IM mode, WZ register, EX latches and Z-80 instruction state to debugger.

BASICG and hires graphics utilities now on built-in Model II TRSDOS boot disk.

Handling of reset button and HALT instruction fixed on Model I.

Clock automatically set for Model 1, 3, 4 built-in TRS-DOS, LDOS and LS-DOS.

Added -is, -ics, -id, -itime, -im trackdump  and -showframe for automatic input "scripting".

Add "Replace" to diskette menu for quicker eject + insert workflow.

Now have -m3n for Norcom emulation (99% just a different character ROM).

Bug fixes in screenshot when paused.

Beam debug now defaults to blue for conflict colour and shows the data that
would have been displayed if the conflict did not occur.

Display and beam conflict colours selectable on command line with -vc, -vd.

Built-in Model 4 LDOS now configured for 4 floppy drives (it had only 2).


Version 2.0.4 - August 27, 2018
-------------------------------

Major update featuring Model II emulation.
